'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _service = require('./service.js');

var _service2 = _interopRequireDefault(_service);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_Service) {
    _inherits(_class, _Service);

    function _class() {
        _classCallCheck(this, _class);

        return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
    }

    _createClass(_class, [{
        key: 'list',
        value: function list() {
            var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : { page: 1, per: 20 };

            if (options.per < 1 || options.per > 100) throw new Error('Per must be between 1 and 100');
            return this.sendRequest('payments?page=' + options.page + '&per=' + options.per, 'GET').then(function (res) {
                return res.payments;
            });
        }
    }, {
        key: 'fetch',
        value: function fetch(id) {
            return this.sendRequest('payments/' + id);
        }
    }, {
        key: 'refund',
        value: function refund(receipt, option) {
            var id = void 0;
            var params = {};
            if ((typeof receipt === 'undefined' ? 'undefined' : _typeof(receipt)) == "object" && receipt.id) id = receipt.id;else if (typeof receipt == "string") id = receipt;else throw new Error("Please provide a valid payment object or payment id");
            if (option && option.amount) {
                if (!isNaN(parseFloat(option.amount)) && isFinite(option.amount)) {
                    params = {
                        amount: option.amount
                    };
                } else {
                    throw new Error("Please provide a valid amount");
                }
            }
            return this.sendRequest('payments/' + id + '/refund', 'POST', params);
        }
    }, {
        key: 'update',
        value: function update(payment) {
            if (typeof payment.id != "string") {
                throw new Error('Payment object does not have id');
            }
            return this.sendRequest('payments/' + payment.id, 'PUT', payment).then(function (res) {
                return res;
            });
        }
    }]);

    return _class;
}(_service2.default);

exports.default = _class;
module.exports = exports.default;